<template>
  <el-dialog :title="title" v-model="isShowDialog" width="90vw" :before-close="beforeClose">

    <div style="height: 80vh;overflow-y: auto;">
      <div style="display: flex;justify-content: end;margin-bottom: 5px;">
        <!-- <el-button type="primary" v-loading="loadingShow" @click="onloadExcel">
          <el-icon>
            <Download />
          </el-icon>
          <span>导出</span>
        </el-button> -->
      </div>
      <MOSTY.PageTree :searchType="'03'" :isShowLeftTree="false">

        <template #serach>
        </template>
        <template #table>
          <section :style="{ 'height': totalHeight }">
            <MOSTY.Table :table-columns="tableColumns" :tableData="tableData" :tableloading="tableloading"
              :isSelect="false" :isSort="false" :tableHeight="'100%'" :actionsW="300">

              <template #costFee="{ row }">
                {{ row.costFee || 0 }}
              </template>
              <template #state="{ row }">
                <dict-tag v-if="row.state" :options="stateOpt" :value="row.state" :tag="true" />
                <span v-else>无</span>
              </template>
              <template #actions="{ row }">
                <span class="operesee" @click="seeDetail(row)"><el-icon>
                    <Compass />
                  </el-icon>查看明细
                </span>

                <span v-if="isEdit && row.orgid.replace('XN', '') == ssbmid" class="operedit"
                  @click="seeDetail(row, 'edit')"><el-icon>
                    <EditPen />
                  </el-icon>使用登记
                </span>
              </template>

            </MOSTY.Table>
          </section>

        </template>

      </MOSTY.PageTree>

      <YsPage v-if="isShowPageList" :isEdit="isEditTc" :title="`${currRow.orgname}-详情`" :years="props.years"
        :row="currRow" @close="pageListClose" />
    </div>
  </el-dialog>

</template>

<script setup>
// 引入
import { reactive, onMounted, ref, getCurrentInstance, nextTick, watch, computed, defineProps, defineEmits } from 'vue'
import { ElMessage } from "element-plus";
import * as MOSTY from "@/components/MyComponents/index";
import { getApi, deleteApi, putApi, postApi } from "@/api/tobAcco_api.js";
import { exportXlsx, downloadImg } from "@/excel/Export2Excel.js";
import { getItem } from "@/utils/storage";
import { filterYear, filterqx } from "@/utils/auth.js";
import YsPage from './YsPage.vue';
import { numAdd } from "@/utils/tools.js";
import Big from "@/utils/big.js"

const { proxy } = getCurrentInstance();
// const { D_BZ_YSFYLB,  } = proxy.$dict("D_BZ_YSFYLB",);
const props = defineProps(['years', 'row', 'isEdit'])
const emits = defineEmits(['close'])

const xgsTCTitle = ref('')
const isShowPageList = ref(false)
/**单位id */
const ssdwid = getItem("deptId").ssdwid;
/** 部门id */
const ssbmid = getItem("deptId").ssbmid;

const isEditTc = ref(false)
const sybmlist = ref([])
const loadingShow = ref(false);
const addplanShow = ref(false);
const addysShow = ref(false);
/** 当前层级 1省 2市 3县 */
const currLev = ref(3) // 1 省 2 市 3 县
/** 是否显示 审核弹框 */
const isShowAuditDialog = ref(false)
const isShowTimeLine = ref(false)
const isShowSubmitAllAudit = ref(false)

/** 当前查看或审核行 */
const currRow = ref({})
const dialogType = ref('see') // see 查看  edit 编辑
const dialogTitle = ref('')
const searchArr = reactive([
  {
    showType: "year",
    prop: "years",
    width: '250px',
    defaultVal: new Date().getFullYear().toString(),

  },
]);

const beforeClose = () => {
  emits('close')
}


const stateOpt = [
  { label: '未上报', value: '0', elTagType: 'ysshpf-oper-red' },
  { label: '部门已上报', value: '1' },
  { label: '县安全部门负责人审批', value: '2' },
  { label: '市安全部门负责人汇总', value: '3' },
  { label: '市安全部门负责人审核', value: '4' },
  { label: '省安全部门负责人审核', value: '5' },
  { label: '审批通过', value: '6' },
];

const tableloading = ref(false)
const USERID = getItem("USERID")
const ssdept = getItem("deptId")
const title = ref('');//弹窗标题
const isShowDialog = ref(true);

const type = ref('01');//控制弹窗参数(01:年初预算调整审核新增)
const rowid = ref(null)
const listQuery = reactive({
  // pageCurrent: 1,
  // pageSize: 20,
  years: props.years,
  orgid: props.row.orgid,
  // ctype: null
});
const isOpen = ref(false);
const tableData = ref([])

const pageConfiger = reactive({
  pageSize: 20,
  pageCurrent: 1,
  total: 0
})
const tableColumns = reactive([
  {
    title: "部门",
    prop: "orgname",
    width: '200',
    sortable: true
  },

  {
    title: "年初批复预算",
    prop: "first_approved_budget",
    width: '160',
  },
  {
    title: "中期调整增减数",
    prop: "tzzj",
    width: '160',
  },

  {
    title: "预算金额",
    prop: "budget",
    width: '200',
  },
  {
    title: "使用金额",
    prop: "cost_fee",
  },
  {
    title: "剩余金额",
    prop: "syFee",
  },
  // {
  //   title: "中期归口审核增减数",
  //   prop: "gkshzj",
  // },
  {
    title: "操作",
    prop: "actions",
    fixed: 'right',
    slot: true
  }
])

const deptid = ref(null)
const orgids = ref(null)
const totalHeight = ref(null)
const getHeight = ref(null)
watch(() => isOpen.value, (val) => {
  nextTick(() => {
    totalHeight.value = `calc(80vh - 40px)`
  })
}, {
  deep: true,
  immediate: true
})
const auditDialogClose = () => {
  isShowAuditDialog.value = false
  getDataList()
}
onMounted(() => {
  getDataList()
})
//获取年初查询年初统计

//刷新
function resetTable(val) {
  listQuery.pageSize = 20
  listQuery.pageCurrent = 1
  // listQuery.orgid = orgids.value;
  // listQuery.ctype = ''
  deptid.value = ''
  listQuery.years = new Date().getFullYear().toString()
  getDataList();
}

//查询
function onSearch(obj) {
  listQuery.pageCurrent = 1
  // listQuery.ctype = obj.ctype;
  listQuery.years = obj.years;
  // listQuery.cwkm = obj.cwkm;
  getDataList();
  // getTotaldata()
}

function getDataList() {
  tableloading.value = true;
  const params = {
    years: listQuery.years,
    orgid: listQuery.orgid,
  }
  getApi(params, "/mosty-jcgl/ysCost/getList")
    .then((res) => {
      tableData.value = []
      if (res) {
        tableData.value = res;
        tableData.value.forEach(async (item) => {
          item.budgetmoney = item.budgetmoney ? item.budgetmoney : 0;
          item.budget = item.budget ? item.budget : 0;
          item.tzzj = item.tzzj ? item.tzzj : 0;
          item.gkshzj = item.gkshzj ? item.gkshzj : 0;
          item.total = item.budget + item.tzzj + item.gkshzj;
          item.total = Math.round(item.total * 10000) / 10000;
          item.syFee = Math.round((item.total - item.cost_fee) * 10000) / 10000;
        });
        pageConfiger.total = res.total;
      }
    }).finally(() => {
      tableloading.value = false;
    })
}


//分页
const handleSizeChange = (currentSize) => {
  listQuery.pageSize = currentSize;
  pageConfiger.pageSize = currentSize;
  getDataList();
};
const handleCurrentChange = (currentPage) => {
  listQuery.pageCurrent = currentPage;
  pageConfiger.pageCurrent = currentPage;
  getDataList();
};
/**获取剩余金额 */
function getSyMoney(row = {}) {
  // 剩余金额 = 年初批复 + 中期调整 - 使用金额
  return row.budgetmoney || 0
  // return new Big(row.first_approved_budget || 0).plus(row.tzzj || 0).minus(row.costFee || 0).round(4).toString()
}

//导出Excel
function onloadExcel() {
  let title = {
    budgettitle: '预算项目',
    cwkm: '财务科目',
    ctype: '预算类别',
    orgname: '使用部门',
    costFee: '使用金额(万元)',
    symoney: '剩余金额(万元)',
    budgetmoney: '年初预算调整金额(万元)',
    budget: '年初批复',
    tzzj: '中期调整增减数',
    gkshzj: '中期归口审核增减数',
    state: '状态',
  }
  loadingShow.value = true
  const params = {
    pageCurrent: 1,
    pageSize: 9999999,
    deptid: props.row?.orgid,
    years: props.years,
  }
  getApi(params, '/mosty-jcgl/ys/getDeptItem').then(async (res) => {
    if (res) {
      let data = Array.isArray(res?.records) ? res?.records : [];
      if (data.length) {
        for (let i = 0; i < data.length; i++) {
          data[i].deptname = data[i].deptname || ''
          // data[i].ctype = proxy.$getDictVal(data[i].ctype, D_BZ_YSFYLB);
          // data[i].cwkm = proxy.$getDictVal(data[i].cwkm, D_TB_YSCWKU);
          data[i].budget = data[i].budget ? data[i].budget : 0
          data[i].first_approved_budget = data[i].first_approved_budget ? data[i].first_approved_budget : 0
          data[i].budgetmoney = data[i].budgetmoney ? data[i].budgetmoney : 0
          data[i].tzzj = data[i].tzzj ? data[i].tzzj : 0
          data[i].gkshzj = data[i].gkshzj ? data[i].gkshzj : 0
          data[i].state = stateOpt.find(item => item.value == data[i].state)?.label || ''
          data[i].yeartzzj = data[i].yeartzzj ? data[i].yeartzzj : 0
          data[i].yeargkshzj = data[i].yeargkshzj ? data[i].yeargkshzj : 0
          data[i].pfjeall = numAdd("add", 4, data[i].budget, data[i].totalcost, data[i].yeargkshzj)
          let total = data[i].budget + data[i].tzzj + data[i].gkshzj
          // data[i].symoney = total - data[i].costFee
          // data[i].symoney = Math.round(data[i].symoney * 10000) / 10000
          data[i].symoney = getSyMoney(data[i])

        }
        let tablename = `${props.row.orgname}-详情.xlsx`
        exportXlsx(title, data, `${props.row.orgname}-详情`, tablename);
      } else {
        ElMessage.warning("暂无数据");
      }
    }

  }).finally(err => {
    loadingShow.value = false
  })
}
const seeDetail = (row, type) => {
  currRow.value = row
  xgsTCTitle.value = `${row.orgname}-查看详情`
  isEditTc.value = type === 'edit'
  isShowPageList.value = true
}
const pageListClose = () => {
  isShowPageList.value = false
  getDataList()
}

</script>

<style lang="scss" scoped>
::v-deep .bigBox {
  height: initial;
}

::v-deep .bigBox .zy-right {
  margin-left: 0;
}

.btnBox {
  display: flex;
  align-items: center;
  justify-content: flex-end;
  margin-bottom: 12px;
}

.toggle {
  height: 40px;
  cursor: pointer;
  display: flex;
  align-items: center;
  color: #0f3916;

  .el-icon {
    transform: rotate(90deg);
    transition: all 0.25s ease;
  }

  &.active {
    .el-icon {
      transform: rotate(-90deg);
    }
  }
}
</style>
